score = {blue = 0, red = 0}
local A2ACounter = {blue = 0,red = 0}
local groupCounter = 2000
local unitCounter = 2000
local pilotDownCounter = {blue = 0,red = 0}
local pilotCounter = {blue = 0,red = 0}
local bomberCounter = {blue = 0,red = 0}
local HS_opponent = {blue = 'red',red = 'blue'}
local difficulty = 'hard'
local difficultyTexts = {
							hard = 'All AI MiG-21Bis spawned from now on will carry a full load of missiles',
							medium = 'All AI MiG-21Bis spawned from now on will carry only IR missiles',
							easy = 'All AI MiG-21Bis spawned from now on are gun only',
						}
local loadOuts = 	{
						hard = 						
						{
							[1] = 
							{
								["CLSID"] = "{R-60 2L}",
							}, -- end of [1]
							[2] = 
							{
								["CLSID"] = "{R-3R}",
							}, -- end of [2]
							[3] = 
							{
								["CLSID"] = "{PTB_490C_MIG21}",
							}, -- end of [3]
							[4] = 
							{
								["CLSID"] = "{R-3R}",
							}, -- end of [4]
							[5] = 
							{
								["CLSID"] = "{R-60 2R}",
							}, -- end of [5]
							[6] = 
							{
								["CLSID"] = "{ASO-2}",
							}, -- end of [6]
						}, -- end of ["pylons"]
						medium =
						{
							[1] = 
							{
								["CLSID"] = "{R-60}",
							}, -- end of [1]
							[5] = 
							{
								["CLSID"] = "{R-60}",
							}, -- end of [5]
							[6] = 
							{
								["CLSID"] = "{ASO-2}",
							}, -- end of [6]
							[3] = 
							{
								["CLSID"] = "{PTB_800_MIG21}",
							}, -- end of [3]
						}, -- end of ["pylons"]
						easy = 
						{
							[3] = 
							{
								["CLSID"] = "{PTB_800_MIG21}",
							}, -- end of [3]
							[6] = 
							{
								["CLSID"] = "{ASO-2}",
							}, -- end of [6]
						}, -- end of ["pylons"]
						}

local headingTexts = {'north','north-east','east','south-east','south','south-west','west','north-west'}

clientNames =	{
					'Enfield 1-1',
					'Enfield 2-1',
					'Enfield 3-1',
					'Enfield 3-2',
					'Enfield 3-3',
					'Enfield 3-4',
					'Springfield 1-1',
					'Springfield 2-1',
					'Springfield 3-1',
					'Springfield 3-2',
					'Springfield 3-3',
					'Springfield 3-4',
					'Springfield 4-1',
					'Dodge 1-1',
					'Dodge 2-1',
					'Dodge 3-1',
					'Dodge 3-2',
					'Dodge 3-3',
					'Dodge 3-4',
					'Ford 1-1',
					'Ford 2-1',
					'Ford 3-1',
					'Ford 3-2',
					'Ford 3-3',
					'Ford 3-4',
				}

local greetingTexts =	{
							['MiG-21Bis'] = ', your task is to obtain air superiority in the skies over Georgia. Radios: Ch. 0 for  flights, Ch. 1 for airfield, Ch 2 for AWACS',
							['F-5E-3'] = ', your task is to obtain air superiority in the skies over Georgia. Radios: Ch. 1 for  flights, Ch. 2 for airfield, Ch 3 for AWACS',
						}
	
detectionZoneList =	{
						'off the coast between Poti and Kobuleti',
						'Zugdidi',
						'Poti',
						'Kobuleti',
						'Kutaisi',
						'Martvili',
						'Honi',
						'Kur Bahrnaro',
						'Abasha',
						'10 nm south of Kutaisi City',
						'Lanchhuti',
						'Ozurgeti',
						'Tshaltubo',
						'Chkhorotsku',
						'10 nm north of Poti',
						'Samtredia',
						'10 nm east of Batumi City',
					}
coalitions = {'blue','red'}
local menu = {
			}				
				
local i

function getHeading(unit, rawHeading)
	local unitpos = unit:getPosition()
	if unitpos then
		local Heading = math.atan2(unitpos.x.z, unitpos.x.x)
		if Heading < 0 then
			Heading = Heading + 2*math.pi  -- put heading in range of 0 to 2*pi
		end
		return Heading
	end
end

HS_incoming = function(arg) -- this is the main routine, coa contains the name of the coalition that was targeted by the missile
local i

	local coa = arg[1]
	local event = arg[2]
	local weapon = event.weapon
	if Weapon.isExist(weapon) then
		for i=1,#clientNames do -- loop of all client helicopter in the mission that belong to the target coalition
			local playerName = clientNames[i]
			local playerUnit = Unit.getByName(playerName) -- get unit
			if playerUnit then -- is unit alive?
				if Unit.getTypeName(playerUnit) ~= 'Ka-50' then
					if (coa == 'blue' and Unit.getCoalition(playerUnit) == coalition.side.BLUE) or (coa == 'red' and Unit.getCoalition(playerUnit) == coalition.side.RED) then
						local position = Weapon.getPosition(weapon).p -- get position of missile
						local playerPosition = Unit.getPosition(playerUnit).p -- get position of helicopter
						local relativePosition = {x=position.x-playerPosition.x, y=position.y-playerPosition.y, z=position.z-playerPosition.z}
						if math.sqrt(relativePosition.x*relativePosition.x+relativePosition.y*relativePosition.y+relativePosition.z*relativePosition.z) < 5000 then -- was the missile launch within the detection range?
							local playerHeading = getHeading(playerUnit) -- the rest of the code determines the 'o'clock' bearing of the missile relative to the helicopter
							local headingVector = {x = math.cos(playerHeading),y=0,z=math.sin(playerHeading)}
							local headingVectorPerpendicular = {x = math.cos(playerHeading+math.pi/2),y=0,z=math.sin(playerHeading+math.pi/2)}
							local forwardDistance = relativePosition.x*headingVector.x+relativePosition.y*headingVector.y+relativePosition.z*headingVector.z
							local rightDistance = relativePosition.x*headingVectorPerpendicular.x+relativePosition.y*headingVectorPerpendicular.y+relativePosition.z*headingVectorPerpendicular.z
							local angle = math.atan2(rightDistance,forwardDistance)*180/math.pi
							if angle < 0 then
								angle = 360+angle
							end
							angle = math.floor(angle*12/360+0.5)
							if angle == 0 then
								angle = 12
							end
							local text = ', go defensive. Incoming ' .. angle .. ' oclock'
							trigger.action.outSoundForGroup(Group.getID(Unit.getGroup(playerUnit)),'incoming.ogg') -- output warning text and audio
							trigger.action.outTextForGroup(Group.getID(Unit.getGroup(playerUnit)),playerName .. text,1) -- output warning text and audio
						end
					end
				end
			end
		end
		timer.scheduleFunction(HS_incoming,{coa,event},timer.getTime()+1) -- next warning will occur in 1 second
	end
end

wasSpotted = function(pilotName,name)
	local fighterOrBomber = ''
	
	local pilotUnit = Unit.getByName(pilotName)
	if pilotUnit then
		if pilotUnit:getTypeName() == 'B-52H' or pilotUnit:getTypeName() == 'Tu-22M3' then
			fighterOrBomber = 'bomber'
		else
			fighterOrBomber = 'fighter'
		end
		local pilotSide = Unit.getCoalition(pilotUnit)
		local pilotPosition = Unit.getPosition(pilotUnit).p
		local angels = math.max(math.floor(pilotPosition.y/333),1)
		local heading = getHeading(pilotUnit)
		heading = (heading + 45/360*math.pi) % (2*math.pi)
		heading = math.floor(heading/2/math.pi*8)+1
		local headingText = headingTexts[heading]
		if pilotSide == coalition.side.BLUE then
			trigger.action.outSoundForCoalition(coalition.side.BLUE,'RadioClickAfter.ogg')
			trigger.action.outTextForCoalition(coalition.side.BLUE,'This is ' .. pilotName .. ' to fighter command. Overflying ' .. name .. ' at angels ' .. angels .. ', flowing ' .. headingText,10)
			trigger.action.outSoundForCoalition(coalition.side.RED,'RadioClickAfter.ogg')
			trigger.action.outTextForCoalition(coalition.side.RED,'Enemy ' .. fighterOrBomber .. ' has been spotted overflying ' .. name .. ' at angels ' .. angels .. ', flowing ' .. headingText .. '. The spotter has marked his position by blue smoke.',10)
			trigger.action.smoke({x = pilotPosition.x, y = math.max(land.getHeight({x = pilotPosition.x, y = pilotPosition.z}),0),z = pilotPosition.z}, trigger.smokeColor.Blue)
		else
			trigger.action.outSoundForCoalition(coalition.side.RED,'RadioClickAfter.ogg')
			trigger.action.outTextForCoalition(coalition.side.RED,'This is ' .. pilotName .. ' to fighter command. Overflying ' .. name .. ' at angels ' .. angels .. ', flowing ' .. headingText,10)
			trigger.action.outSoundForCoalition(coalition.side.BLUE,'RadioClickAfter.ogg')
			trigger.action.outTextForCoalition(coalition.side.BLUE,'Enemy ' .. fighterOrBomber .. ' has been spotted overflying ' .. name .. ' at angels ' .. angels .. ', flowing ' .. headingText .. '. The spotter has marked his position by red smoke.',10)
			trigger.action.smoke({x = pilotPosition.x, y = math.max(land.getHeight({x = pilotPosition.x, y = pilotPosition.z}),0),z = pilotPosition.z}, trigger.smokeColor.Red)
		end
	end
end

overflyCheck = function(arg)
local zonePosition

	local zoneName = arg[1]
	local pilotName = arg[2]
	local groupName = arg[3]
	zonePosition = nil
	local zone = trigger.misc.getZone(zoneName)
	if zone then
		zonePosition = zone.point
	else
		local airbase = Airbase.getByName(zoneName)
		if airbase then
			zonePosition = Airbase.getPosition(airbase).p
		end
	end
	if zonePosition then
		local pilotUnit = Unit.getByName(pilotName)
		if pilotUnit then
			local pilotSide = Unit.getCoalition(pilotUnit)
			local pilotPosition = Unit.getPosition(pilotUnit).p
			local distance = math.sqrt((zonePosition.x-pilotPosition.x)*(zonePosition.x-pilotPosition.x)+(zonePosition.z-pilotPosition.z)*(zonePosition.z-pilotPosition.z))
			if distance < 5000 then
				if Unit.inAir(pilotUnit) then
					wasSpotted(pilotName,zoneName)
				end
				timer.scheduleFunction(overflyCheck,{zoneName,pilotName,groupName},timer.getTime()+60)
			else
				-- trigger.action.outTextForCoalition(pilotSide,pilotName .. ' is ' .. math.floor(distance) .. ' m from ' .. zoneName,10)
				timer.scheduleFunction(overflyCheck,{zoneName,pilotName,groupName},timer.getTime()+1+distance/300)
			end
		else
			local group = Group.getByName(groupName)
			local count
			pilotUnit = nil
			local units = Group.getUnits(group)
			if units then
				for count = 1,#units do
					local unit = units[count]
					if unit then
						if Unit.isExist(unit) then
							pilotUnit = unit
							break
						end
					end
				end
			end
			if pilotUnit then
				timer.scheduleFunction(overflyCheck,{zoneName,Unit.getName(pilotUnit),groupName},timer.getTime()+60)
			end
		end
	end
end

doSpot = function(groupName)
	local group = Group.getByName(groupName)
	local count,pilotUnit
	local units = Group.getUnits(group)
	if units then
		for count = 1,#units do
			local unit = units[count]
			if unit then
				if Unit.isExist(unit) then
					pilotUnit = unit
					break
				end
			end
		end
	end
	if pilotUnit then
		local pilotName = Unit.getName(pilotUnit)
		local pilotSide = Unit.getCoalition(pilotUnit)
		local pilotPosition = Unit.getPosition(pilotUnit).p
		local count
		for count = 1,#airbaseList do
			local airbase = airbaseList[count]
			if airbase then
				local airbaseName = Airbase.getName(airbase)
				local airbasePosition = Airbase.getPosition(airbase).p
				local distance = math.sqrt((airbasePosition.x-pilotPosition.x)*(airbasePosition.x-pilotPosition.x)+(airbasePosition.z-pilotPosition.z)*(airbasePosition.z-pilotPosition.z))
				-- trigger.action.outTextForCoalition(pilotSide,pilotName .. ' is ' .. math.floor(distance) .. ' m from ' .. airbaseName,10)
				timer.scheduleFunction(overflyCheck,{airbaseName,pilotName,groupName},timer.getTime()+1+distance/100)
			end
		end
		for count = 1,#detectionZoneList do
			local zoneName = detectionZoneList[count]
			local zone = trigger.misc.getZone(zoneName)
			if zone then
				local zonePosition = zone.point
				local distance = math.sqrt((zonePosition.x-pilotPosition.x)*(zonePosition.x-pilotPosition.x)+(zonePosition.z-pilotPosition.z)*(zonePosition.z-pilotPosition.z))
				-- trigger.action.outTextForCoalition(pilotSide,pilotName .. ' is ' .. math.floor(distance) .. ' m from ' .. zoneName,10)
				timer.scheduleFunction(overflyCheck,{zoneName,pilotName,groupName},timer.getTime()+1+distance/100)
			end
		end
	end
end

checkForFlag = function(arg)
	local flagName = arg[1]
	local code = arg[2]
	local arguments = arg[3]
	if trigger.misc.getUserFlag(flagName) == 1 then
		trigger.action.setUserFlag(flagName,0)
		timer.scheduleFunction(code,arguments,timer.getTime()+0.1)
	end
	timer.scheduleFunction(checkForFlag,{flagName,code,arguments},timer.getTime()+1)
end

clientBecomesActive = function(pilotName)
	local pilotUnit = Unit.getByName(pilotName)
	if pilotUnit then
		local pilotSide = Unit.getCoalition(pilotUnit)
		local pilotPosition = Unit.getPosition(pilotUnit).p
		trigger.action.outSoundForCoalition(pilotSide,'RadioClickAfter.ogg')
		trigger.action.outTextForCoalition(pilotSide,'To all units. We have a new ' .. pilotUnit:getTypeName() .. ' pilot: ' .. Unit.getName(pilotUnit),30)
		if pilotName == 'Springfield 4-1' or pilotName == 'Ford 3-1' then
			trigger.action.outTextForCoalition(Unit.getCoalition(pilotUnit),pilotName .. ', your flight is loaded with bombs. Engage enemy ships and truck convoys.',30)		
		elseif greetingTexts[pilotUnit:getTypeName()] then
			trigger.action.outTextForCoalition(Unit.getCoalition(pilotUnit),pilotName .. greetingTexts[pilotUnit:getTypeName()],30)
		end
		if string.find(pilotName, "Dodge") or string.find(pilotName, "Ford") then
			A2ACounter.blue = A2ACounter.blue+1
			trigger.action.outText('There are now ' .. A2ACounter.blue .. ' blue client A2A fighters active.',30)
		end
		if string.find(pilotName, "Enfield") or string.find(pilotName, "Springfield") then
			A2ACounter.red = A2ACounter.red+1
			trigger.action.outText('There are now ' .. A2ACounter.red .. ' red client A2A fighters active.',30)
		end
		local group = Unit.getGroup(pilotUnit)
		if group then
			local groupName = Group.getName(group)
			doSpot(groupName)
			local groupID = Group.getID(group)
			if groupID then
				menu[pilotName] = groupID
				trigger.action.addOtherCommandForGroup(groupID, 'Flares for VID for ' .. pilotName, 'Flares for VID for ' .. pilotName) -- add radio item to "F10" menu
				trigger.action.setUserFlag('Flares for VID for ' .. pilotName,0)
				timer.scheduleFunction(checkForFlag,{'Flares for VID for ' .. pilotName,flare,pilotName},timer.getTime()+1)
				if pilotUnit:getTypeName() == 'F-5E-3' then
					trigger.action.addOtherCommandForGroup(groupID, 'Cycle through enemy fighter difficulty for ' .. pilotName, 'Cycle through enemy fighter difficulty for ' .. pilotName) -- add radio item to "F10" menu
					trigger.action.setUserFlag('Cycle through enemy fighter difficulty for ' .. pilotName,0)
					timer.scheduleFunction(checkForFlag,{'Cycle through enemy fighter difficulty for ' .. pilotName,setDifficulty,pilotName},timer.getTime()+1)
				end
			end
		end
	end
end

clientBecomesInactive = function(pilotName)
	trigger.action.outSound('RadioClickAfter.ogg')
	trigger.action.outText('To all units. Pilot ' .. pilotName .. ' has left us.',20)
	if string.find(pilotName, "Dodge") or string.find(pilotName, "Ford") then
		A2ACounter.blue = A2ACounter.blue-1
		trigger.action.outText('There are now ' .. A2ACounter.blue .. ' blue client A2A fighters active.',30)
	end
	if string.find(pilotName, "Enfield") or string.find(pilotName, "Springfield") then
		A2ACounter.red = A2ACounter.red-1
		trigger.action.outText('There are now ' .. A2ACounter.red .. ' red client A2A fighters active.',30)
	end
	if menu[pilotName] then
		trigger.action.removeOtherCommandForGroup(menu[pilotName], 'Flares for VID for ' .. pilotName, 'Flares for VID for ' .. pilotName) -- add radio item to "F10" menu
		trigger.action.removeOtherCommandForGroup(menu[pilotName], 'Cycle through enemy fighter difficulty for ' .. pilotName, 'Cycle through enemy fighter difficulty for ' .. pilotName) -- add radio item to "F10" menu
	end
end

HS_onBecomesActiveDo_sub1 = function(arguments)
	local unitName = arguments[2]
	if Unit.getByName(unitName) and not arguments[1] then
		timer.scheduleFunction(clientBecomesActive,unitName,timer.getTime()+0.1)
		timer.scheduleFunction(HS_onBecomesInactiveDo_sub1,{true,unitName},timer.getTime()+1)
	elseif not arguments[1] then
		timer.scheduleFunction(HS_onBecomesActiveDo_sub1,{false,unitName},timer.getTime()+0.1)
	end
end

HS_onBecomesInactiveDo_sub1 = function(arguments)
	local unitName = arguments[2]
	if Unit.getByName(unitName) then
		timer.scheduleFunction(HS_onBecomesInactiveDo_sub1,{true,unitName},timer.getTime()+0.1)
	elseif arguments[1] then
		if string.find(unitName, "Vehicle") then
			if string.find(unitName, "blue") then
				trigger.action.outText('A blue vehicle has been destroyed, red side gains 10 points.',20)
				score.red = score.red + 10
			else
				trigger.action.outText('A red vehicle has been destroyed, blue side gains 10 points.',20)
				score.blue = score.blue + 10
			end
		elseif string.find(unitName, "Ship") then
			if string.find(unitName, "blue") then
				trigger.action.outText('A blue ship has been destroyed, red side gains 25 points.',20)
				score.red = score.red + 25
			else
				trigger.action.outText('A red ship has been destroyed, blue side gains 25 points.',20)
				score.blue = score.blue + 25
			end
		else
			timer.scheduleFunction(clientBecomesInactive,unitName,timer.getTime()+0.1)
			timer.scheduleFunction(HS_onBecomesActiveDo_sub1,{false,unitName},timer.getTime()+0.1)
		end
	end
end

generateAAA = function(coa)
local count,countryName,unitType,centralPointx,centralPointx,position2

	centerPointx = trigger.misc.getZone(coa .. ' AAA Zone').point.x
	centerPointy = trigger.misc.getZone(coa .. ' AAA Zone').point.z
	radius = trigger.misc.getZone(coa .. ' AAA Zone').radius
	if coa == 'blue' then
		countryName = 'USA'		
	else
		countryName = 'RUSSIA'
	end
	position2 = { x = 0, y = 0 }
	for count = 1,10 do
		if coa == 'blue' then
			if count < 6 then
				unitType = 'Stinger manpad'
			else
				unitType = 'Vulcan'
			end
		else
			if count < 6 then
				unitType = 'SA-18 Igla-S manpad'
			else
				unitType = 'Ural-375 ZU-23'
			end
		end
		repeat
			position2.x = centerPointx-radius+myRandom(2*radius)
			position2.y = centerPointy-radius+myRandom(2*radius)
		until land.getSurfaceType(position2) ~= land.SurfaceType.SHALLOW_WATER and land.getSurfaceType(position2) ~= land.SurfaceType.WATER
		groupCounter = groupCounter+1
		unitCounter = unitCounter+1
		coalition.addGroup(country.id[countryName], Unit.Category["GROUND_UNIT"], {
			["visible"] = false,
			["route"] = 
			{
				["spans"] = 
				{
				}, -- end of ["spans"]
				["points"] = 
				{
					[1] = 
					{
						["alt"] = 0,
						["type"] = "Turning Point",
						["ETA"] = 0,
						["alt_type"] = "RADAR",
						["formation_template"] = "",
						["y"] = position2.y,
						["x"] = position2.x,
						["name"] = "",
						["ETA_locked"] = true,
						["speed"] = 0,
						["action"] = "Off Road",
						["task"] = 
						{
							["id"] = "ComboTask",
							["params"] = 
							{
								["tasks"] = 
								{
								}, -- end of ["tasks"]
							}, -- end of ["params"]
						}, -- end of ["task"]
						["speed_locked"] = true,
					}, -- end of [1]
				}, -- end of ["points"]
			}, -- end of ["route"]
			["groupId"] = groupCounter,
			["tasks"] = 
			{
			}, -- end of ["tasks"]
			["hidden"] = false,
			["units"] = 
			{
				[1] = 
				{
					["type"] = unitType,
					["transportable"] = 
					{
						["randomTransportable"] = false,
					}, -- end of ["transportable"]
					["unitId"] = unitCounter,
					["skill"] = "Random",
					["y"] = position2.y,
					["x"] = position2.x,
					["name"] = coa .. ' AAA Unit #' .. count,
					["playerCanDrive"] = true,
					["heading"] = 0,
				}, -- end of [1]
			}, -- end of ["units"]
			["y"] = position2.y,
			["x"] = position2.x,
			["name"] = coa .. ' AAA Group #' .. count,
			["start_time"] = 0,
			["task"] = "Ground Nothing",
		})
	end
end

spawnFighter = function(coa)
	local count
	local waypoints = {}
	local points = {}
	local centerPointx = trigger.misc.getZone('Fighter Zone').point.x
	local centerPointy = trigger.misc.getZone('Fighter Zone').point.z
	local radius = trigger.misc.getZone('Fighter Zone').radius
	for count = 1,6 do
		waypoints[count] ={}
		waypoints[count].y = centerPointy-radius+myRandom(2*radius)
		waypoints[count].x = centerPointx-radius+myRandom(2*radius)
		table.insert(points,{
							["alt"] = 6096,
							["type"] = "Turning Point",
							["action"] = "Turning Point",
							["alt_type"] = "BARO",
							["formation_template"] = "",
							["properties"] = 
							{
								["vnav"] = 1,
								["scale"] = 0,
								["angle"] = 0,
								["vangle"] = 0,
								["steer"] = 2,
							}, -- end of ["properties"]
							["ETA"] = 0,
							["y"] = waypoints[count].y,
							["x"] = waypoints[count].x,
							["name"] = "",
							["speed"] = 69.444444444444,
							["ETA_locked"] = false,
							["task"] = 
							{
								["id"] = "ComboTask",
								["params"] = 
								{
									["tasks"] = 
									{
									}, -- end of ["tasks"]
								}, -- end of ["params"]
							}, -- end of ["task"]
							["speed_locked"] = true,
						})
	end
	centerPointx = trigger.misc.getZone(coa .. ' Fighter Zone').point.x
	centerPointy = trigger.misc.getZone(coa .. ' Fighter Zone').point.z
	radius = trigger.misc.getZone(coa .. ' Fighter Zone').radius
	points[1].y = centerPointy-radius+myRandom(2*radius)
	points[1].x = centerPointx-radius+myRandom(2*radius)
	points[1].ETA_locked = true
	points[1].task = {
		["id"] = "ComboTask",
		["params"] = 
		{
			["tasks"] = 
			{
				[1] = 
				{
					["enabled"] = true,
					["key"] = "FighterSweep",
					["id"] = "EngageTargets",
					["number"] = 1,
					["auto"] = true,
					["params"] = 
					{
						["targetTypes"] = 
						{
							[1] = "Planes",
						}, -- end of ["targetTypes"]
						["priority"] = 0,
					}, -- end of ["params"]
				}, -- end of [1]
			}, -- end of ["tasks"]
		}, -- end of ["params"]
	}
	points[6].task = {
		["id"] = "ComboTask",
		["params"] = 
		{
			["tasks"] = 
			{
				[1] = 
				{
					["enabled"] = true,
					["auto"] = false,
					["id"] = "WrappedAction",
					["number"] = 1,
					["params"] = 
					{
						["action"] = 
						{
							["id"] = "SwitchWaypoint",
							["params"] = 
							{
								["goToWaypointIndex"] = 2,
								["fromWaypointIndex"] = 6,
							}, -- end of ["params"]
						}, -- end of ["action"]
					}, -- end of ["params"]
				}, -- end of [1]
			}, -- end of ["tasks"]
		}, -- end of ["params"]
	}
	groupCounter = groupCounter+1
	unitCounter = unitCounter +1
	pilotCounter[coa] = pilotCounter[coa] +1
	local groupName = coa .. ' fighter AI Group #' .. pilotCounter[coa]
	local unitName = coa .. ' fighter AI Unit #' .. pilotCounter[coa]
	if coa == 'blue' then
		coalition.addGroup(country.id.USA, Unit.Category["AIRPLANE"], {
			["modulation"] = 0,
			["radioSet"] = false,
			["task"] = "Fighter Sweep",
			["uncontrolled"] = false,
			["taskSelected"] = true,
			["route"] = 
			{
				["points"] = points
			}, -- end of ["route"]
			["hidden"] = false,
			["units"] = 
			{
				[1] = 
				{
					["alt"] = 6096,
					["hardpoint_racks"] = true,
					["alt_type"] = "BARO",
					["livery_id"] = "USAF 'Southeast Asia'",
					["skill"] = "Random",
					["speed"] = 152.77777777778,
					["type"] = "F-5E-3",
					["unitId"] = unitCounter,
					["psi"] = -0.1672834992885,
					["y"] = points[1].y,
					["x"] = points[1].x,
					["name"] = unitName,
					["payload"] = 
					{
						["pylons"] = 
						{
							[1] = 
							{
								["CLSID"] = "{AIM-9P5}",
							}, -- end of [1]
							[7] = 
							{
								["CLSID"] = "{AIM-9P5}",
							}, -- end of [7]
							[4] = 
							{
								["CLSID"] = "{PTB-150GAL}",
							}, -- end of [4]
						}, -- end of ["pylons"]
						["fuel"] = 2046,
						["flare"] = 15,
						["ammo_type"] = 1,
						["chaff"] = 30,
						["gun"] = 100,
					}, -- end of ["payload"]
					["heading"] = -1.4896291831607,
					["callsign"] = 
					{
						[1] = 4,
						[2] = 1+(pilotCounter.blue / 4)%4,
						[3] = 1+pilotCounter.blue%4,
						["name"] = unitName,
					}, -- end of ["callsign"]
					["onboard_num"] = '1' .. pilotCounter.blue,
				}, -- end of [1]
			}, -- end of ["units"]
			["y"] = points[1].y,
			["x"] = points[1].x,
			["name"] = groupName,
			["groupId"] = groupCounter,
			["communication"] = true,
			["frequency"] = 305,
		})
	else
		coalition.addGroup(country.id.RUSSIA, Unit.Category["AIRPLANE"], {
			["modulation"] = 0,
			["radioSet"] = false,
			["task"] = "CAP",
			["uncontrolled"] = false,
			["taskSelected"] = true,
			["route"] = 
			{
				["points"] = points
			}, -- end of ["route"]
			["hidden"] = false,
			["units"] = 
			{
				[1] = 
				{
					["alt"] = 6096,
					["hardpoint_racks"] = true,
					["alt_type"] = "BARO",
					["livery_id"] = "VVS Camo",
					["skill"] = "Random",
					["speed"] = 152.77777777778,
					["type"] = "MiG-21Bis",
					["unitId"] = unitCounter,
					["psi"] = -0.1672834992885,
					["y"] = points[1].y,
					["x"] = points[1].x,
					["name"] = unitName,
					["payload"] = 
					{
						["pylons"] = loadOuts[difficulty],
						["fuel"] = 2280,
						["flare"] = 40,
						["ammo_type"] = 1,
						["chaff"] = 18,
						["gun"] = 100,
					}, -- end of ["payload"]
					["heading"] = -1.4896291831607,
					["callsign"] = 900+pilotCounter.red,
				}, -- end of [1]
			}, -- end of ["units"]
			["y"] = points[1].y,
			["x"] = points[1].x,
			["name"] = groupName,
			["groupId"] = groupCounter,
			["communication"] = true,
			["frequency"] = 124,
		})
	end
	local count
	airbaseList = world.getAirbases()
	for count = 1,#airbaseList do
		local airbase = airbaseList[count]
		if Airbase.isExist(airbase) then
			local airbaseName = Airbase.getName(airbase)
			timer.scheduleFunction(overflyCheck,{airbaseName,unitName,groupName},timer.getTime()+60)
		end
	end
	for count = 1,#detectionZoneList do
		local zoneName = detectionZoneList[count]
		local zone = trigger.misc.getZone(zoneName)
		if zone then
			timer.scheduleFunction(overflyCheck,{zoneName,unitName,groupName},timer.getTime()+60)
		end
	end
end

function myRandom(firstNum, secondNum) -- no support for decimals
	local lowNum, highNum
	if not secondNum then
		highNum = firstNum
		lowNum = 1
	else
		lowNum = firstNum
		highNum = secondNum
	end
	local total = 1
	if math.abs(highNum - lowNum + 1) < 50 then -- if total values is less than 50
		total = math.modf(50/math.abs(highNum - lowNum + 1)) -- make x copies required to be above 50
	end
	local choices = {}
	for i = 1, total do -- iterate required number of times
		for x = lowNum, highNum do -- iterate between the range
			choices[#choices +1] = x -- add each entry to a table
		end
	end
	local rtnVal = math.random(#choices) -- will now do a math.random of at least 50 choices
	for i = 1, 10 do
		rtnVal = math.random(#choices) -- iterate a few times for giggles
	end
	return choices[rtnVal]
end

countFighters = function(coa)
local count,aircraftList

	count = 0
	if coa == 'blue' then
		aircraftList = coalition.getGroups(coalition.side.BLUE , Group.Category.AIRPLANE)
	else
		aircraftList = coalition.getGroups(coalition.side.RED , Group.Category.AIRPLANE)
	end
	local i
	for i = 1,#aircraftList do
		local group = aircraftList[i]
		if group then
			local units = Group.getUnits(group)
			local j
			for j=1,#units do
				local unit = units[j]
				if unit then
					if Unit.isExist(unit) and Unit.inAir(unit) then
						if Unit.getTypeName(unit) ~= 'B-52H' and Unit.getTypeName(unit) ~= 'Tu-22M3' then
							count = count + 1
						end
					end
				end
			end
		end
	end
	return(count)
end

activateFighter = function()
	local i
	local blueFighters = countFighters('blue')
	local redFighters = countFighters('red')
	-- trigger.action.outText('There are ' .. blueFighters .. ' blue fighters and ' .. redFighters .. ' red fighters.',30)
	if blueFighters == redFighters then
		if redFighters < 10 then
			-- trigger.action.outText('spawning red fighter',10)
			timer.scheduleFunction(spawnFighter,'red',timer.getTime()+1)
		end
		if blueFighters < 10 then
			-- trigger.action.outText('spawning blue fighter',10)
			timer.scheduleFunction(spawnFighter,'blue',timer.getTime()+2)
		end
	elseif blueFighters > redFighters then 
		for i = 1,blueFighters-redFighters do
			-- trigger.action.outText('spawning red fighter',10)
			if redFighters < 10 then
				timer.scheduleFunction(spawnFighter,'red',timer.getTime()+i)
			end
		end
	elseif blueFighters < redFighters then 
		for i = 1,redFighters-blueFighters do
			-- trigger.action.outText('spawning blue fighter',10)
			if blueFighters < 10 then
				timer.scheduleFunction(spawnFighter,'blue',timer.getTime()+i)
			end
		end
	end
	timer.scheduleFunction(activateFighter,nil,timer.getTime()+myRandom(15*60))
end

activateBomber = function(coa)
	bomberCounter[coa] = bomberCounter[coa]+1
	local groupName = coa .. ' Bomber Group #' .. bomberCounter[coa]
	local group = Group.getByName(groupName)
	if group then
		local controller = Group.getController(group)
		if controller then
			local task =	{
								["number"] = 1,
								["auto"] = false,
								["id"] = "WrappedAction",
								["enabled"] = true,
								["params"] = 
								{
									["action"] = 
									{
										["id"] = "Start",
										["params"] = 
										{
										}, -- end of ["params"]
									}, -- end of ["action"]
								}, -- end of ["params"]
							}
			Controller.setTask(controller,task)
		end
		doSpot(groupName)
	end
	timer.scheduleFunction(activateBomber,coa,timer.getTime()+myRandom(45*60))
end

closestLandmark = function(pilotPosition)
	local count,closestDistance,closestName,closestPosition
	closestDistance = 1E6
	closestName = nil
	closestPosition = nil
	airbaseList = world.getAirbases()
	for count = 1,#airbaseList do
		local airbase = airbaseList[count]
		if airbase then
			local airbaseName = Airbase.getName(airbase)
			local airbasePosition = Airbase.getPosition(airbase).p
			local distance = math.sqrt((airbasePosition.x-pilotPosition.x)*(airbasePosition.x-pilotPosition.x)+(airbasePosition.z-pilotPosition.z)*(airbasePosition.z-pilotPosition.z))
			-- trigger.action.outText(' is ' .. math.floor(distance) .. ' m from ' .. airbaseName,10)
			if distance < closestDistance then
				closestDistance = distance
				closestName = airbaseName
				closestPosition = airbasePosition
			end
		end
	end
	for count = 1,#detectionZoneList do
		local zoneName = detectionZoneList[count]
		local zone = trigger.misc.getZone(zoneName)
		if zone then
			local zonePosition = zone.point
			local distance = math.sqrt((zonePosition.x-pilotPosition.x)*(zonePosition.x-pilotPosition.x)+(zonePosition.z-pilotPosition.z)*(zonePosition.z-pilotPosition.z))
			-- trigger.action.outText(' is ' .. math.floor(distance) .. ' m from ' .. zoneName,10)
			if distance < closestDistance then
				closestDistance = distance
				closestName = zoneName
				closestPosition = zonePosition
			end
		end
	end
	return ({name = closestName,p = closestPosition})
end

truckSighted = function(groupName)
local i,truckUnit,coa

	local group = Group.getByName(groupName)
	if group then
		for i = 1,5 do
			truckUnit = Group.getUnits(group)[i]
			if truckUnit then
				break
			end
		end
		if truckUnit then
			local side = Unit.getCoalition(truckUnit)			
			local truckPosition = Unit.getPosition(truckUnit).p
			local landmark = closestLandmark(truckPosition)
			local landmarkPosition = landmark.p
			local distance = math.sqrt((landmarkPosition.x-truckPosition.x)*(landmarkPosition.x-truckPosition.x)+(landmarkPosition.z-truckPosition.z)*(landmarkPosition.z-truckPosition.z))
			local heading = math.atan2(truckPosition.z-landmarkPosition.z, truckPosition.x-landmarkPosition.x)
			if heading < 0 then
				heading = heading + 2*math.pi  -- put heading in range of 0 to 2*pi
			end
			heading = (heading + 45/360*math.pi) % (2*math.pi)
			heading = math.floor(heading/2/math.pi*8)+1
			local headingText = headingTexts[heading]
			heading = getHeading(truckUnit)
			heading = (heading + 45/360*math.pi) % (2*math.pi)
			heading = math.floor(heading/2/math.pi*8)+1
			local headingText2 = headingTexts[heading]
			if side == coalition.side.RED then
				trigger.action.outSoundForCoalition(coalition.side.BLUE,'RadioClickAfter.ogg')
				trigger.action.outTextForCoalition(coalition.side.BLUE,groupName .. ' has been spotted ' .. math.floor(distance/1600) .. ' miles ' .. headingText .. ' of ' .. landmark.name .. ', driving ' .. headingText2 .. ', marked by red and green smoke.',20)
				trigger.action.smoke(truckPosition, trigger.smokeColor.Red)
			else
				trigger.action.outSoundForCoalition(coalition.side.RED,'RadioClickAfter.ogg')
				trigger.action.outTextForCoalition(coalition.side.RED,groupName .. ' has been spotted ' .. math.floor(distance/1600) .. ' miles ' .. headingText .. ' of ' .. landmark.name .. ', driving ' .. headingText2 .. ', marked by blue and green smoke.',20)
				trigger.action.smoke(truckPosition, trigger.smokeColor.Blue)
			end
			trigger.action.smoke({x = truckPosition.x+50,y = truckPosition.y,z = truckPosition.z+50}, trigger.smokeColor.Green)
			timer.scheduleFunction(truckSighted,groupName,timer.getTime()+myRandom(10*60))
		end
	end
end

shipSighted = function(groupName)
local i,shipUnit,coa

	local group = Group.getByName(groupName)
	if group then
		for i = 1,5 do
			shipUnit = Group.getUnits(group)[i]
			if shipUnit then
				break
			end
		end
		if shipUnit then
			local side = Unit.getCoalition(shipUnit)			
			local shipPosition = Unit.getPosition(shipUnit).p
			local landmark = closestLandmark(shipPosition)
			local landmarkPosition = landmark.p
			local distance = math.sqrt((landmarkPosition.x-shipPosition.x)*(landmarkPosition.x-shipPosition.x)+(landmarkPosition.z-shipPosition.z)*(landmarkPosition.z-shipPosition.z))
			local heading = math.atan2(shipPosition.z-landmarkPosition.z, shipPosition.x-landmarkPosition.x)
			if heading < 0 then
				heading = heading + 2*math.pi  -- put heading in range of 0 to 2*pi
			end
			heading = (heading + 45/360*math.pi) % (2*math.pi)
			heading = math.floor(heading/2/math.pi*8)+1
			local headingText = headingTexts[heading]
			heading = getHeading(shipUnit)
			heading = (heading + 45/360*math.pi) % (2*math.pi)
			heading = math.floor(heading/2/math.pi*8)+1
			local headingText2 = headingTexts[heading]
			if side == coalition.side.RED then
				trigger.action.outSoundForCoalition(coalition.side.BLUE,'RadioClickAfter.ogg')
				trigger.action.outTextForCoalition(coalition.side.BLUE,groupName .. ' has been spotted ' .. math.floor(distance/1600) .. ' miles ' .. headingText .. ' of ' .. landmark.name .. ', flowing ' .. headingText2 .. '.',20)
			else
				trigger.action.outSoundForCoalition(coalition.side.RED,'RadioClickAfter.ogg')
				trigger.action.outTextForCoalition(coalition.side.RED,groupName .. ' has been spotted ' .. math.floor(distance/1600) .. ' miles ' .. headingText .. ' of ' .. landmark.name .. ', flowing ' .. headingText2 .. '.',20)
			end
			timer.scheduleFunction(shipSighted,groupName,timer.getTime()+myRandom(10*60))
		end
	end
end

local count

printScore = function()
	trigger.action.outText('Blue score: ' .. score.blue .. ', red score: ' .. score.red,20)
	timer.scheduleFunction(printScore,nil,timer.getTime() + 60)
end

respondEvent = function(event) -- there is a pilot down
local unitType,coa,countryName,position3,position2,unitCategory

	-- if event.id == world.event.S_EVENT_HIT then -- was there a weapons launch by one of the SAM sites?
		-- if event.initiator then
			-- if Unit.isExist(event.initiator) then
				-- if Unit.getCoalition(event.initiator) == coalition.side.RED then
					-- trigger.action.outText('Blue pilot has been shot down, red side gains 10 points.',20)
					-- score.red = score.red + 10
				-- else
					-- trigger.action.outText('Red pilot has been shot down, blue side gains 10 points.',20)
					-- score.blue = score.blue + 10
				-- end
			-- end
		-- end
	-- end
	if event.id == world.event.S_EVENT_PILOT_DEAD then -- was there a weapons launch by one of the SAM sites?
		if event.initiator then
			if Unit.isExist(event.initiator) then
				if Unit.getCoalition(event.initiator) == coalition.side.BLUE then
					trigger.action.outText('Blue pilot has been shot down, red side gains 10 points.',20)
					score.red = score.red + 10
				else
					trigger.action.outText('Red pilot has been shot down, blue side gains 10 points.',20)
					score.blue = score.blue + 10
				end
			end
		end
	end
	if event.id == world.event.S_EVENT_SHOT then -- was there a weapons launch by one of the SAM sites?
		if event.initiator then
			if Unit.isExist(event.initiator) then
				if Unit.getCoalition(event.initiator) == coalition.side.BLUE then
					timer.scheduleFunction(HS_incoming,{'red',event},timer.getTime() + 1) -- warning will be given after reactionTime seconds
				else
					timer.scheduleFunction(HS_incoming,{'blue',event},timer.getTime() + 1) -- warning will be given after reactionTime seconds
				end
			end
		end
	end
	-- if event.id == world.event.S_EVENT_DEAD then -- was there a weapons launch by one of the SAM sites?
		-- local outText = 'unit killed'
		-- if event.initiator then
			-- outText = outText .. ', initiator: ' .. Object.getName(event.initiator)
		-- end
		-- if event.target then
			-- outText = outText .. ', target: ' .. Object.getName(event.target)
		-- end
		-- trigger.action.outText(outText,20)
	-- end
	if event.id == world.event.S_EVENT_EJECTION then
		local pilotUnit = event.initiator
		if pilotUnit then
			local side = Unit.getCoalition(pilotUnit)
			if side == coalition.side.BLUE then
				trigger.action.outText('A blue pilot ejected, red side gains 10 points.',20)
				score.red = score.red + 10
			else
				trigger.action.outText('A red pilot ejected, blue side gains 10 points.',20)
				score.blue = score.blue + 10
			end
		end
	end
end

flare = function(pilotName)
	local pilotUnit = Unit.getByName(pilotName)
	if pilotUnit then
		local pilotSide = Unit.getCoalition(pilotUnit)
		trigger.action.outTextForCoalition(pilotSide,'[all friendly aircraft and helos are releasing a flare.]',10)
		local aircraftList = coalition.getGroups(pilotSide , Group.Category.AIRPLANE)
		local i
		for i = 1,#aircraftList do
			local group = aircraftList[i]
			if group then
				local units = Group.getUnits(group)
				local j
				for j = 1,#units do
					local unit = units[j]
					if unit then
						trigger.action.signalFlare(Unit.getPosition(unit).p, trigger.flareColor.White, 0)
					end
				end
			end	
		end
	end
end

setDifficulty = function(pilotName)
	if difficulty == 'hard' then
		difficulty = 'medium'
	elseif difficulty == 'medium' then
		difficulty = 'easy'
	elseif difficulty == 'easy' then
		difficulty = 'hard'
	end
	trigger.action.outText(difficultyTexts[difficulty],30)
end

local handler = {}
handler.id = 1000
handler.f = respondEvent
function handler:onEvent(event)
	self.f(event)
end
world.addEventHandler(handler)

airbaseList = world.getAirbases()

for count = 1,#clientNames do
	timer.scheduleFunction(HS_onBecomesActiveDo_sub1,{false,clientNames[count]},timer.getTime()+1)
end

generateAAA('blue')
generateAAA('red')
timer.scheduleFunction(activateFighter,nil,timer.getTime()+myRandom(10*60))
timer.scheduleFunction(activateBomber,'blue',timer.getTime()+myRandom(30*60))
timer.scheduleFunction(activateBomber,'red',timer.getTime()+myRandom(30*60))

for count = 1,4 do
	timer.scheduleFunction(truckSighted,'blue Vehicle Group #' .. count,timer.getTime()+myRandom(10*60))
	timer.scheduleFunction(truckSighted,'red Vehicle Group #' .. count,timer.getTime()+myRandom(10*60))
	local count2
	local group = Group.getByName('blue Vehicle Group #' .. count)
	if group then
		local units = Group.getUnits(group)
		if units then
			for count2 = 1,#units do
				local unit = units[count2]
				if unit then
					timer.scheduleFunction(HS_onBecomesInactiveDo_sub1,{true,Unit.getName(unit)},timer.getTime()+1)
				end
			end
		end
	end
	group = Group.getByName('red Vehicle Group #' .. count)
	if group then
		local units = Group.getUnits(group)
		if units then
			for count2 = 1,#units do
				local unit = units[count2]
				if unit then
					timer.scheduleFunction(HS_onBecomesInactiveDo_sub1,{true,Unit.getName(unit)},timer.getTime()+1)
				end
			end
		end
	end
end
for count = 1,3 do
	timer.scheduleFunction(shipSighted,'blue Ship Group #' .. count,timer.getTime()+myRandom(10*60))
	timer.scheduleFunction(HS_onBecomesInactiveDo_sub1,{true,'blue Ship Group #' .. count .. ' Unit #1'},timer.getTime()+1)
	timer.scheduleFunction(shipSighted,'red Ship Group #' .. count,timer.getTime()+myRandom(10*60))
	timer.scheduleFunction(HS_onBecomesInactiveDo_sub1,{true,'red Ship Group #' .. count .. ' Unit #1'},timer.getTime()+1)
end

timer.scheduleFunction(printScore,nil,timer.getTime() + 60)